# Bootmagic

<!-- FIXME: Describe the bootmagic feature here. -->

## Bootmagic Keycodes

Shortcuts for bootmagic options. You can use these even when bootmagic is off.

|Key                               |Aliases  |Description                         |
|----------------------------------|---------|------------------------------------|
|`MAGIC_SWAP_CONTROL_CAPSLOCK`     |         |Swap Left Control and Caps Lock     |
|`MAGIC_CAPSLOCK_TO_CONTROL`       |         |Treat Caps Lock as Control          |
|`MAGIC_SWAP_LALT_LGUI`            |         |Swap Left Alt and GUI               |
|`MAGIC_SWAP_RALT_RGUI`            |         |Swap Right Alt and GUI              |
|`MAGIC_NO_GUI`                    |         |Disable the GUI key                 |
|`MAGIC_SWAP_GRAVE_ESC`            |         |Swap <code>&#96;</code> and Escape  |
|`MAGIC_SWAP_BACKSLASH_BACKSPACE`  |         |Swap Backslash and Backspace        |
|`MAGIC_HOST_NKRO`                 |         |Force NKRO on                       |
|`MAGIC_SWAP_ALT_GUI`              |`AG_SWAP`|Swap Alt and GUI on both sides      |
|`MAGIC_UNSWAP_CONTROL_CAPSLOCK`   |         |Unswap Left Control and Caps Lock   |
|`MAGIC_UNCAPSLOCK_TO_CONTROL`     |         |Stop treating CapsLock as Control   |
|`MAGIC_UNSWAP_LALT_LGUI`          |         |Unswap Left Alt and GUI             |
|`MAGIC_UNSWAP_RALT_RGUI`          |         |Unswap Right Alt and GUI            |
|`MAGIC_UNNO_GUI`                  |         |Enable the GUI key                  |
|`MAGIC_UNSWAP_GRAVE_ESC`          |         |Unswap <code>&#96;</code> and Escape|
|`MAGIC_UNSWAP_BACKSLASH_BACKSPACE`|         |Unswap Backslash and Backspace      |
|`MAGIC_UNHOST_NKRO`               |         |Force NKRO off                      |
|`MAGIC_UNSWAP_ALT_GUI`            |`AG_NORM`|Unswap Left Alt and GUI             |
|`MAGIC_TOGGLE_NKRO`               |         |Turn NKRO on or off                 |


## Bootmagc Hotkeys

Use this by holding the SPACEBAR and the documented key while
plugging in the USB connection. e.g. to get into bootloader mode
hold `SPACE` and `B` while plugging in USB.


|Key        |Description                                                             |
|-----------|------------------------------------------------------------------------|
|`ESC`      | Skip bootmagic and saved eeprom configuration                          |
|`B`        | Enter bootloader instead of firmware                                   |
|`BACKSPACE`| Clear the saved settings from flash                                    |
|`LCTRL`    | Swap `Control` and `Capslock` and save into flash                      |
|`CAPSLOCK` | Swap `Capslock` and `Control` and save into flash                      |
|`LALT`     | Swap Left `Alt` and `GUI` and save into flash, e.g. for OSX Opt and Cmd|
|`RALT`     | Swap Right `Alt` and `GUI` and save into flash                         |
|`LGUI`     | Disable GUI key - e.g. disable Windows key during gaming               |
|`GRAVE`    | Swap &#39; and `ESC` and save into flash                               |
|`BACKSLASH`| Swap Blackslash and Backspace and save into flash                      |
|`N`        | Enable NKRO (N Key Roll Over)                                          |
|`0`        | Make Layer 0 the default layer at bootup, e.g. switch to dvorak        |
|`1`        | Make Layer 1 the default layer at bootup                               |
|`2`        | Make Layer 2 the default layer at bootup                               |
|`3`        | Make Layer 3 the default layer at bootup                               |
|`4`        | Make Layer 4 the default layer at bootup                               |
|`5`        | Make Layer 5 the default layer at bootup                               |
|`6`        | Make Layer 6 the default layer at bootup                               |
|`7`        | Make Layer 7 the default layer at bootup                               |





